/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.236 Revision 1.349
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.236 2006/06/04 13:25:04 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.349 2010/08/19 21:32:26 vapier Exp $
4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
4# 14#
5# This eclass is for general purpose functions that most ebuilds 15# Due to the nature of this eclass, some functions may have maintainers
6# have to implement themselves. 16# different from the overall eclass!
7#
8# NB: If you add anything, please comment it!
9 17
10inherit multilib portability 18inherit multilib portability
11 19
12DEPEND="!bootstrap? ( sys-devel/patch )"
13RDEPEND=""
14# sys-apps/shadow is needed for useradd, etc, bug #94745.
15
16DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
17 21
18# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
19# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
20# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
21# must be an integer greater than zero. 25# @USAGE: [seconds]
22# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
23epause() { 31epause() {
24 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
25 sleep ${1:-5}
26 fi
27} 33}
28 34
29# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
30# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
31# don't beep. 37# @DESCRIPTION:
32# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
33ebeep() { 42ebeep() {
34 local n 43 local n
35 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
36 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
37 echo -ne "\a" 46 echo -ne "\a"
38 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
39 echo -ne "\a" 48 echo -ne "\a"
40 sleep 1 49 sleep 1
41 done 50 done
42 fi 51 fi
43} 52}
44 53
45# This function generate linker scripts in /usr/lib for dynamic 54else
46# libs in /lib. This is to fix linking problems when you have
47# the .so in /lib, and the .a in /usr/lib. What happens is that
48# in some cases when linking dynamic, the .a in /usr/lib is used
49# instead of the .so in /lib due to gcc/libtool tweaking ld's
50# library search path. This cause many builds to fail.
51# See bug #4411 for more info.
52#
53# To use, simply call:
54#
55# gen_usr_ldscript libfoo.so
56#
57# Note that you should in general use the unversioned name of
58# the library, as ldconfig should usually update it correctly
59# to point to the latest version of the library present.
60#
61# <azarah@gentoo.org> (26 Oct 2002)
62#
63gen_usr_ldscript() {
64 local lib libdir=$(get_libdir)
65 # Just make sure it exists
66 dodir /usr/${libdir}
67 55
68 for lib in "${@}" ; do 56ebeep() {
69 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
70 /* GNU ld script 58}
71 Since Gentoo has critical dynamic libraries
72 in /lib, and the static versions in /usr/lib,
73 we need to have a "fake" dynamic lib in /usr/lib,
74 otherwise we run into linking problems.
75 59
76 See bug http://bugs.gentoo.org/4411 for more info. 60epause() {
77 */ 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
78 GROUP ( /${libdir}/${lib} ) 62}
79 END_LDSCRIPT 63
80 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
77# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove CVS directories recursiveley. Useful when a source tarball contains
81# internal CVS directories. Defaults to $PWD.
82ecvs_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
85 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
86}
87
88# @FUNCTION: esvn_clean
89# @USAGE: [list of dirs]
90# @DESCRIPTION:
91# Remove .svn directories recursiveley. Useful when a source tarball contains
92# internal Subversion directories. Defaults to $PWD.
93esvn_clean() {
94 [[ -z $* ]] && set -- .
95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
96}
97
98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
116# return 0
117# fi
81 done 118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
82} 134}
83 135
136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
84 154
85# Default directory where patches are located 155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
86EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
87# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
88EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
89# Default options for patch 165# Default options for patch:
166# @CODE
90# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
91# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 168# --no-backup-if-mismatch - do not leave .orig files behind
92# Set -E to automatically remove empty files. 169# -E - automatically remove empty files
170# @CODE
93EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
95# and not the full path .. 175# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
97# Change the printed message for a single patch. 179# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
181# @VARIABLE: EPATCH_MULTI_MSG
182# @DESCRIPTION:
99# Change the printed message for multiple patches. 183# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 185# @VARIABLE: EPATCH_FORCE
102# 186# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 187# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 188# arch naming style.
105EPATCH_FORCE="no" 189EPATCH_FORCE="no"
106 190
107# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
108# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
109# 199#
110# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
111# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
112# 202#
113# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
114# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
115# 205# ${EPATCH_FORCE} == "yes"
116# Above EPATCH_* variables can be used to control various defaults,
117# bug they should be left as is to ensure an ebuild can rely on
118# them for.
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
125# 215#
126# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
127# 218#
128# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 220epatch() {
141 _epatch_draw_line() { 221 _epatch_draw_line() {
222 # create a line of same length as input string
142 [[ -z $1 ]] && set "$(printf "%65s" '')" 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 echo "${1//?/=}" 224 echo "${1//?/=}"
144 } 225 }
145 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
146 local PIPE_CMD=""
147 local STDERR_TARGET="${T}/$$.out"
148 local PATCH_TARGET="${T}/$$.patch"
149 local PATCH_SUFFIX=""
150 local SINGLE_PATCH="no"
151 local x=""
152 226
153 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
154 228
155 if [ "$#" -gt 1 ] 229 # Let the rest of the code process one user arg at a time --
156 then 230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
157 local m="" 233 local m
158 for m in "$@" ; do 234 for m in "$@" ; do
159 epatch "${m}" 235 epatch "${m}"
160 done 236 done
161 return 0 237 return 0
162 fi 238 fi
163 239
164 if [ -n "$1" -a -f "$1" ] 240 local SINGLE_PATCH="no"
165 then 241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
243
244 if [[ -f $1 ]] ; then
166 SINGLE_PATCH="yes" 245 SINGLE_PATCH="yes"
167 246 set -- "$1"
168 local EPATCH_SOURCE="$1" 247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
169 local EPATCH_SUFFIX="${1##*\.}" 249 local EPATCH_SUFFIX=$1
170 250
171 elif [ -n "$1" -a -d "$1" ] 251 elif [[ -d $1 ]] ; then
172 then 252 # Some people like to make dirs of patches w/out suffixes (vim)
173 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
174 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 254
255 else
256 # sanity check ... if it isn't a dir or file, wtf man ?
257 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
258 echo
259 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
260 eerror
261 eerror " ${EPATCH_SOURCE}"
262 eerror " ( ${EPATCH_SOURCE##*/} )"
263 echo
264 die "Cannot find \$EPATCH_SOURCE!"
265 fi
266
267 local PIPE_CMD
268 case ${EPATCH_SUFFIX##*\.} in
269 xz) PIPE_CMD="xz -dc" ;;
270 lzma) PIPE_CMD="lzma -dc" ;;
271 bz2) PIPE_CMD="bzip2 -dc" ;;
272 gz|Z|z) PIPE_CMD="gzip -dc" ;;
273 ZIP|zip) PIPE_CMD="unzip -p" ;;
274 *) ;;
275 esac
276
277 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
278
279 local x
280 for x in "$@" ; do
281 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
282 # didn't match anything, ignore continue on
283 [[ ! -f ${x} ]] && continue
284
285 local patchname=${x##*/}
286
287 # Apply single patches, or forced sets of patches, or
288 # patches with ARCH dependant names.
289 # ???_arch_foo.patch
290 # Else, skip this input altogether
291 local a=${patchname#*_} # strip the ???_
292 a=${a%%_*} # strip the _foo.patch
293 if ! [[ ${SINGLE_PATCH} == "yes" || \
294 ${EPATCH_FORCE} == "yes" || \
295 ${a} == all || \
296 ${a} == ${ARCH} ]]
175 then 297 then
176 local EPATCH_SOURCE="$1/*" 298 continue
299 fi
300
301 # Let people filter things dynamically
302 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
303 # let people use globs in the exclude
304 eshopts_push -o noglob
305
306 local ex
307 for ex in ${EPATCH_EXCLUDE} ; do
308 if [[ ${patchname} == ${ex} ]] ; then
309 eshopts_pop
310 continue 2
311 fi
312 done
313
314 eshopts_pop
315 fi
316
317 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
318 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
319 einfo "${EPATCH_SINGLE_MSG}"
320 else
321 einfo "Applying ${patchname} ..."
322 fi
177 else 323 else
178 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 324 einfo " ${patchname} ..."
179 fi 325 fi
180 else 326
181 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 327 # most of the time, there will only be one run per unique name,
182 then 328 # but if there are more, make sure we get unique log filenames
183 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 329 local STDERR_TARGET="${T}/${patchname}.out"
184 then 330 if [[ -e ${STDERR_TARGET} ]] ; then
185 EPATCH_SOURCE="$1" 331 STDERR_TARGET="${T}/${patchname}-$$.out"
332 fi
333
334 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
335
336 # Decompress the patch if need be
337 local count=0
338 local PATCH_TARGET
339 if [[ -n ${PIPE_CMD} ]] ; then
340 PATCH_TARGET="${T}/$$.patch"
341 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
342
343 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
344 echo
345 eerror "Could not extract patch!"
346 #die "Could not extract patch!"
347 count=5
348 break
186 fi 349 fi
350 else
351 PATCH_TARGET=${x}
352 fi
187 353
354 # Check for absolute paths in patches. If sandbox is disabled,
355 # people could (accidently) patch files in the root filesystem.
356 # Or trigger other unpleasantries #237667. So disallow -p0 on
357 # such patches.
358 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
359 if [[ -n ${abs_paths} ]] ; then
360 count=1
361 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
362 fi
363
364 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
365 while [[ ${count} -lt 5 ]] ; do
366 # Generate some useful debug info ...
367 (
368 _epatch_draw_line "***** ${patchname} *****"
188 echo 369 echo
189 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 370 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
371 echo
372 _epatch_draw_line "***** ${patchname} *****"
373 ) >> "${STDERR_TARGET}"
374
375 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
376 (
377 _epatch_draw_line "***** ${patchname} *****"
378 echo
379 echo "ACTUALLY APPLYING ${patchname} ..."
380 echo
381 _epatch_draw_line "***** ${patchname} *****"
382 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
383 ) >> "${STDERR_TARGET}"
384
385 if [ $? -ne 0 ] ; then
386 echo
387 eerror "A dry-run of patch command succeeded, but actually"
388 eerror "applying the patch failed!"
389 #die "Real world sux compared to the dreamworld!"
390 count=5
391 fi
392 break
393 fi
394
395 : $(( count++ ))
396 done
397
398 # if we had to decompress the patch, delete the temp one
399 if [[ -n ${PIPE_CMD} ]] ; then
400 rm -f "${PATCH_TARGET}"
401 fi
402
403 if [[ ${count} -ge 5 ]] ; then
404 echo
405 eerror "Failed Patch: ${patchname} !"
406 eerror " ( ${PATCH_TARGET} )"
190 eerror 407 eerror
191 eerror " ${EPATCH_SOURCE}" 408 eerror "Include in your bugreport the contents of:"
192 eerror " ( ${EPATCH_SOURCE##*/} )" 409 eerror
410 eerror " ${STDERR_TARGET}"
193 echo 411 echo
194 die "Cannot find \$EPATCH_SOURCE!"
195 fi
196
197 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
198 fi
199
200 case ${EPATCH_SUFFIX##*\.} in
201 bz2)
202 PIPE_CMD="bzip2 -dc"
203 PATCH_SUFFIX="bz2"
204 ;;
205 gz|Z|z)
206 PIPE_CMD="gzip -dc"
207 PATCH_SUFFIX="gz"
208 ;;
209 ZIP|zip)
210 PIPE_CMD="unzip -p"
211 PATCH_SUFFIX="zip"
212 ;;
213 *)
214 PIPE_CMD="cat"
215 PATCH_SUFFIX="patch"
216 ;;
217 esac
218
219 if [ "${SINGLE_PATCH}" = "no" ]
220 then
221 einfo "${EPATCH_MULTI_MSG}"
222 fi
223 for x in ${EPATCH_SOURCE}
224 do
225 # New ARCH dependant patch naming scheme ...
226 #
227 # ???_arch_foo.patch
228 #
229 if [ -f ${x} ] && \
230 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
231 [ "${EPATCH_FORCE}" = "yes" ])
232 then
233 local count=0
234 local popts="${EPATCH_OPTS}"
235 local patchname=${x##*/}
236
237 if [ -n "${EPATCH_EXCLUDE}" ]
238 then
239 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
240 then
241 continue
242 fi
243 fi
244
245 if [ "${SINGLE_PATCH}" = "yes" ]
246 then
247 if [ -n "${EPATCH_SINGLE_MSG}" ]
248 then
249 einfo "${EPATCH_SINGLE_MSG}"
250 else
251 einfo "Applying ${patchname} ..."
252 fi
253 else
254 einfo " ${patchname} ..."
255 fi
256
257 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
258 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
259
260 # Allow for prefix to differ ... im lazy, so shoot me :/
261 while [ "${count}" -lt 5 ]
262 do
263 # Generate some useful debug info ...
264 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266
267 if [ "${PATCH_SUFFIX}" != "patch" ]
268 then
269 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 else
272 PATCH_TARGET="${x}"
273 fi
274
275 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
277
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280
281 if [ "${PATCH_SUFFIX}" != "patch" ]
282 then
283 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
284 then
285 echo
286 eerror "Could not extract patch!"
287 #die "Could not extract patch!"
288 count=5
289 break
290 fi
291 fi
292
293 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
294 then
295 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
297 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
298 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
299 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300
301 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
302 _epatch_assert
303
304 if [ "$?" -ne 0 ]
305 then
306 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
307 echo
308 eerror "A dry-run of patch command succeeded, but actually"
309 eerror "applying the patch failed!"
310 #die "Real world sux compared to the dreamworld!"
311 count=5
312 fi
313
314 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
315
316 break
317 fi
318
319 count=$((count + 1))
320 done
321
322 if [ "${PATCH_SUFFIX}" != "patch" ]
323 then
324 rm -f ${PATCH_TARGET}
325 fi
326
327 if [ "${count}" -eq 5 ]
328 then
329 echo
330 eerror "Failed Patch: ${patchname} !"
331 eerror " ( ${PATCH_TARGET} )"
332 eerror
333 eerror "Include in your bugreport the contents of:"
334 eerror
335 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
336 echo
337 die "Failed Patch: ${patchname}!" 412 die "Failed Patch: ${patchname}!"
338 fi 413 fi
339 414
340 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 415 # if everything worked, delete the patch log
341 416 rm -f "${STDERR_TARGET}"
342 eend 0 417 eend 0
343 fi
344 done 418 done
345 if [ "${SINGLE_PATCH}" = "no" ] 419
346 then 420 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
347 einfo "Done with patching" 421 : # everything worked
422}
423epatch_user() {
424 [[ $# -ne 0 ]] && die "epatch_user takes no options"
425
426 # don't clobber any EPATCH vars that the parent might want
427 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
428 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
429 EPATCH_SOURCE=${base}/${CTARGET}/${check}
430 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
431 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
432 if [[ -d ${EPATCH_SOURCE} ]] ; then
433 EPATCH_SOURCE=${EPATCH_SOURCE} \
434 EPATCH_SUFFIX="patch" \
435 EPATCH_FORCE="yes" \
436 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
437 epatch
438 return 0
348 fi 439 fi
440 done
441 return 1
349} 442}
350 443
444# @FUNCTION: emktemp
445# @USAGE: [temp dir]
446# @DESCRIPTION:
351# Cheap replacement for when debianutils (and thus mktemp) 447# Cheap replacement for when debianutils (and thus mktemp)
352# does not exist on the users system 448# does not exist on the users system.
353# vapier@gentoo.org
354#
355# Takes just 1 optional parameter (the directory to create tmpfile in)
356emktemp() { 449emktemp() {
357 local exe="touch" 450 local exe="touch"
358 [[ $1 == -d ]] && exe="mkdir" && shift 451 [[ $1 == -d ]] && exe="mkdir" && shift
359 local topdir=$1 452 local topdir=$1
360 453
362 [[ -z ${T} ]] \ 455 [[ -z ${T} ]] \
363 && topdir="/tmp" \ 456 && topdir="/tmp" \
364 || topdir=${T} 457 || topdir=${T}
365 fi 458 fi
366 459
367 if [[ -z $(type -p mktemp) ]] ; then 460 if ! type -P mktemp > /dev/null ; then
461 # system lacks `mktemp` so we have to fake it
368 local tmp=/ 462 local tmp=/
369 while [[ -e ${tmp} ]] ; do 463 while [[ -e ${tmp} ]] ; do
370 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 464 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
371 done 465 done
372 ${exe} "${tmp}" || ${exe} -p "${tmp}" 466 ${exe} "${tmp}" || ${exe} -p "${tmp}"
373 echo "${tmp}" 467 echo "${tmp}"
374 else 468 else
469 # the args here will give slightly wierd names on BSD,
470 # but should produce a usable file on all userlands
375 if [[ ${exe} == "touch" ]] ; then 471 if [[ ${exe} == "touch" ]] ; then
376 [[ ${USERLAND} == "GNU" ]] \
377 && mktemp -p "${topdir}" \
378 || TMPDIR="${topdir}" mktemp -t tmp 472 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
379 else 473 else
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -d "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -dt tmp 474 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
383 fi
384 fi 475 fi
476 fi
385} 477}
386 478
479# @FUNCTION: egetent
480# @USAGE: <database> <key>
481# @MAINTAINER:
482# base-system@gentoo.org (Linux)
483# Joe Jezak <josejx@gmail.com> (OS X)
484# usata@gentoo.org (OS X)
485# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
486# @DESCRIPTION:
387# Small wrapper for getent (Linux), nidump (Mac OS X), 487# Small wrapper for getent (Linux),
488# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
388# and pw (FreeBSD) used in enewuser()/enewgroup() 489# and pw (FreeBSD) used in enewuser()/enewgroup()
389# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
390# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
391#
392# egetent(database, key)
393egetent() { 490egetent() {
394 case ${CHOST} in 491 case ${CHOST} in
395 *-darwin*) 492 *-darwin[678])
396 case "$2" in 493 case "$2" in
397 *[!0-9]*) # Non numeric 494 *[!0-9]*) # Non numeric
398 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 495 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
399 ;; 496 ;;
400 *) # Numeric 497 *) # Numeric
401 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 498 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
499 ;;
500 esac
501 ;;
502 *-darwin*)
503 local mytype=$1
504 [[ "passwd" == $mytype ]] && mytype="Users"
505 [[ "group" == $mytype ]] && mytype="Groups"
506 case "$2" in
507 *[!0-9]*) # Non numeric
508 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
509 ;;
510 *) # Numeric
511 local mykey="UniqueID"
512 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
513 dscl . -search /$mytype $mykey $2 2>/dev/null
402 ;; 514 ;;
403 esac 515 esac
404 ;; 516 ;;
405 *-freebsd*|*-dragonfly*) 517 *-freebsd*|*-dragonfly*)
406 local opts action="user" 518 local opts action="user"
421 getent "$1" "$2" 533 getent "$1" "$2"
422 ;; 534 ;;
423 esac 535 esac
424} 536}
425 537
426# Simplify/standardize adding users to the system 538# @FUNCTION: enewuser
427# vapier@gentoo.org 539# @USAGE: <user> [uid] [shell] [homedir] [groups] [params]
428# 540# @DESCRIPTION:
429# enewuser(username, uid, shell, homedir, groups, extra options) 541# Same as enewgroup, you are not required to understand how to properly add
430# 542# a user to the system. The only required parameter is the username.
431# Default values if you do not specify any: 543# Default uid is (pass -1 for this) next available, default shell is
432# username: REQUIRED ! 544# /bin/false, default homedir is /dev/null, there are no default groups,
433# uid: next available (see useradd(8)) 545# and default params sets the comment as 'added by portage for ${PN}'.
434# note: pass -1 to get default behavior
435# shell: /bin/false
436# homedir: /dev/null
437# groups: none
438# extra: comment of 'added by portage for ${PN}'
439enewuser() { 546enewuser() {
440 case ${EBUILD_PHASE} in 547 case ${EBUILD_PHASE} in
441 unpack|compile|test|install) 548 unpack|compile|test|install)
442 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 549 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
443 eerror "Package fails at QA and at life. Please file a bug." 550 eerror "Package fails at QA and at life. Please file a bug."
450 eerror "No username specified !" 557 eerror "No username specified !"
451 die "Cannot call enewuser without a username" 558 die "Cannot call enewuser without a username"
452 fi 559 fi
453 560
454 # lets see if the username already exists 561 # lets see if the username already exists
455 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then 562 if [[ -n $(egetent passwd "${euser}") ]] ; then
456 return 0 563 return 0
457 fi 564 fi
458 einfo "Adding user '${euser}' to your system ..." 565 einfo "Adding user '${euser}' to your system ..."
459 566
460 # options to pass to useradd 567 # options to pass to useradd
461 local opts= 568 local opts=
462 569
463 # handle uid 570 # handle uid
464 local euid=$1; shift 571 local euid=$1; shift
465 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then 572 if [[ -n ${euid} && ${euid} != -1 ]] ; then
466 if [[ ${euid} -gt 0 ]] ; then 573 if [[ ${euid} -gt 0 ]] ; then
467 if [[ ! -z $(egetent passwd ${euid}) ]] ; then 574 if [[ -n $(egetent passwd ${euid}) ]] ; then
468 euid="next" 575 euid="next"
469 fi 576 fi
470 else 577 else
471 eerror "Userid given but is not greater than 0 !" 578 eerror "Userid given but is not greater than 0 !"
472 die "${euid} is not a valid UID" 579 die "${euid} is not a valid UID"
473 fi 580 fi
474 else 581 else
475 euid="next" 582 euid="next"
476 fi 583 fi
477 if [[ ${euid} == "next" ]] ; then 584 if [[ ${euid} == "next" ]] ; then
478 for euid in $(seq 101 999) ; do 585 for ((euid = 101; euid <= 999; euid++)); do
479 [[ -z $(egetent passwd ${euid}) ]] && break 586 [[ -z $(egetent passwd ${euid}) ]] && break
480 done 587 done
481 fi 588 fi
482 opts="${opts} -u ${euid}" 589 opts="${opts} -u ${euid}"
483 einfo " - Userid: ${euid}" 590 einfo " - Userid: ${euid}"
497 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do 604 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
498 [[ -x ${ROOT}${shell} ]] && break 605 [[ -x ${ROOT}${shell} ]] && break
499 done 606 done
500 607
501 if [[ ${shell} == "/dev/null" ]] ; then 608 if [[ ${shell} == "/dev/null" ]] ; then
502 eerror "Unable to identify the shell to use" 609 eerror "Unable to identify the shell to use, proceeding with userland default."
503 die "Unable to identify the shell to use" 610 case ${USERLAND} in
611 GNU) shell="/bin/false" ;;
612 BSD) shell="/sbin/nologin" ;;
613 Darwin) shell="/usr/sbin/nologin" ;;
614 *) die "Unable to identify the default shell for userland ${USERLAND}"
615 esac
504 fi 616 fi
505 617
506 eshell=${shell} 618 eshell=${shell}
507 fi 619 fi
508 einfo " - Shell: ${eshell}" 620 einfo " - Shell: ${eshell}"
606 fi 718 fi
607 ;; 719 ;;
608 720
609 *) 721 *)
610 if [[ -z $@ ]] ; then 722 if [[ -z $@ ]] ; then
611 useradd ${opts} ${euser} \ 723 useradd -r ${opts} \
612 -c "added by portage for ${PN}" \ 724 -c "added by portage for ${PN}" \
725 ${euser} \
613 || die "enewuser failed" 726 || die "enewuser failed"
614 else 727 else
615 einfo " - Extra: $@" 728 einfo " - Extra: $@"
616 useradd ${opts} ${euser} "$@" \ 729 useradd -r ${opts} "$@" \
730 ${euser} \
617 || die "enewuser failed" 731 || die "enewuser failed"
618 fi 732 fi
619 ;; 733 ;;
620 esac 734 esac
621 735
627 fi 741 fi
628 742
629 export SANDBOX_ON=${oldsandbox} 743 export SANDBOX_ON=${oldsandbox}
630} 744}
631 745
632# Simplify/standardize adding groups to the system 746# @FUNCTION: enewgroup
633# vapier@gentoo.org 747# @USAGE: <group> [gid]
634# 748# @DESCRIPTION:
635# enewgroup(group, gid) 749# This function does not require you to understand how to properly add a
636# 750# group to the system. Just give it a group name to add and enewgroup will
637# Default values if you do not specify any: 751# do the rest. You may specify the gid for the group or allow the group to
638# groupname: REQUIRED ! 752# allocate the next available one.
639# gid: next available (see groupadd(8))
640# extra: none
641enewgroup() { 753enewgroup() {
642 case ${EBUILD_PHASE} in 754 case ${EBUILD_PHASE} in
643 unpack|compile|test|install) 755 unpack|compile|test|install)
644 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function." 756 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
645 eerror "Package fails at QA and at life. Please file a bug." 757 eerror "Package fails at QA and at life. Please file a bug."
653 eerror "No group specified !" 765 eerror "No group specified !"
654 die "Cannot call enewgroup without a group" 766 die "Cannot call enewgroup without a group"
655 fi 767 fi
656 768
657 # see if group already exists 769 # see if group already exists
658 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ] 770 if [[ -n $(egetent group "${egroup}") ]]; then
659 then
660 return 0 771 return 0
661 fi 772 fi
662 einfo "Adding group '${egroup}' to your system ..." 773 einfo "Adding group '${egroup}' to your system ..."
663 774
664 # options to pass to useradd 775 # options to pass to useradd
707 fi 818 fi
708 819
709 # If we need the next available 820 # If we need the next available
710 case ${egid} in 821 case ${egid} in
711 *[!0-9]*) # Non numeric 822 *[!0-9]*) # Non numeric
712 for egid in $(seq 101 999); do 823 for ((egid = 101; egid <= 999; egid++)); do
713 [ -z "`egetent group ${egid}`" ] && break 824 [[ -z $(egetent group ${egid}) ]] && break
714 done 825 done
715 esac 826 esac
716 dscl . create /groups/${egroup} gid ${egid} 827 dscl . create /groups/${egroup} gid ${egid}
717 dscl . create /groups/${egroup} passwd '*' 828 dscl . create /groups/${egroup} passwd '*'
718 ;; 829 ;;
719 830
720 *-freebsd*|*-dragonfly*) 831 *-freebsd*|*-dragonfly*)
721 case ${egid} in 832 case ${egid} in
722 *[!0-9]*) # Non numeric 833 *[!0-9]*) # Non numeric
723 for egid in $(seq 101 999); do 834 for ((egid = 101; egid <= 999; egid++)); do
724 [ -z "`egetent group ${egid}`" ] && break 835 [[ -z $(egetent group ${egid}) ]] && break
725 done 836 done
726 esac 837 esac
727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 838 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
728 ;; 839 ;;
729 840
730 *-netbsd*) 841 *-netbsd*)
731 case ${egid} in 842 case ${egid} in
732 *[!0-9]*) # Non numeric 843 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do 844 for ((egid = 101; egid <= 999; egid++)); do
734 [ -z "`egetent group ${egid}`" ] && break 845 [[ -z $(egetent group ${egid}) ]] && break
735 done 846 done
736 esac 847 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 848 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;; 849 ;;
739 850
740 *) 851 *)
852 # We specify -r so that we get a GID in the system range from login.defs
741 groupadd ${opts} ${egroup} || die "enewgroup failed" 853 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
742 ;; 854 ;;
743 esac 855 esac
744 export SANDBOX_ON="${oldsandbox}" 856 export SANDBOX_ON="${oldsandbox}"
745} 857}
746 858
747# Simple script to replace 'dos2unix' binaries 859# @FUNCTION: edos2unix
748# vapier@gentoo.org 860# @USAGE: <file> [more files ...]
749# 861# @DESCRIPTION:
750# edos2unix(file, <more files> ...) 862# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
863# to remove all of these text utilities from DEPEND variables because this
864# is a script based solution. Just give it a list of files to convert and
865# they will all be changed from the DOS CRLF format to the UNIX LF format.
751edos2unix() { 866edos2unix() {
752 for f in "$@" 867 echo "$@" | xargs sed -i 's/\r$//'
753 do
754 cp "${f}" ${T}/edos2unix
755 sed 's/\r$//' ${T}/edos2unix > "${f}"
756 done
757} 868}
758
759
760##############################################################
761# START: Handle .desktop files and menu entries #
762# maybe this should be separated into a new eclass some time #
763# lanius@gentoo.org #
764##############################################################
765 869
766# Make a desktop file ! 870# Make a desktop file !
767# Great for making those icons in kde/gnome startmenu ! 871# Great for making those icons in kde/gnome startmenu !
768# Amaze your friends ! Get the women ! Join today ! 872# Amaze your friends ! Get the women ! Join today !
769# 873#
770# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 874# make_desktop_entry(<command>, [name], [icon], [type], [fields])
771# 875#
772# binary: what binary does the app run with ? 876# binary: what command does the app run with ?
773# name: the name that will show up in the menu 877# name: the name that will show up in the menu
774# icon: give your little like a pretty little icon ... 878# icon: give your little like a pretty little icon ...
775# this can be relative (to /usr/share/pixmaps) or 879# this can be relative (to /usr/share/pixmaps) or
776# a full path to an icon 880# a full path to an icon
777# type: what kind of application is this ? for categories: 881# type: what kind of application is this ? for categories:
778# http://www.freedesktop.org/Standards/desktop-entry-spec 882# http://standards.freedesktop.org/menu-spec/latest/apa.html
779# path: if your app needs to startup in a specific dir 883# fields: extra fields to append to the desktop file; a printf string
780make_desktop_entry() { 884make_desktop_entry() {
781 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 885 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
782 886
783 local exec=${1} 887 local exec=${1}
784 local name=${2:-${PN}} 888 local name=${2:-${PN}}
785 local icon=${3:-${PN}.png} 889 local icon=${3:-${PN}}
786 local type=${4} 890 local type=${4}
787 local path=${5} 891 local fields=${5}
788 892
789 if [[ -z ${type} ]] ; then 893 if [[ -z ${type} ]] ; then
790 local catmaj=${CATEGORY%%-*} 894 local catmaj=${CATEGORY%%-*}
791 local catmin=${CATEGORY##*-} 895 local catmin=${CATEGORY##*-}
792 case ${catmaj} in 896 case ${catmaj} in
793 app) 897 app)
794 case ${catmin} in 898 case ${catmin} in
899 accessibility) type=Accessibility;;
795 admin) type=System;; 900 admin) type=System;;
901 antivirus) type=System;;
902 arch) type=Archiving;;
903 backup) type=Archiving;;
796 cdr) type=DiscBurning;; 904 cdr) type=DiscBurning;;
797 dicts) type=Dictionary;; 905 dicts) type=Dictionary;;
906 doc) type=Documentation;;
798 editors) type=TextEditor;; 907 editors) type=TextEditor;;
799 emacs) type=TextEditor;; 908 emacs) type=TextEditor;;
800 emulation) type=Emulator;; 909 emulation) type=Emulator;;
801 laptop) type=HardwareSettings;; 910 laptop) type=HardwareSettings;;
802 office) type=Office;; 911 office) type=Office;;
912 pda) type=PDA;;
803 vim) type=TextEditor;; 913 vim) type=TextEditor;;
804 xemacs) type=TextEditor;; 914 xemacs) type=TextEditor;;
805 *) type=;;
806 esac 915 esac
807 ;; 916 ;;
808 917
809 dev) 918 dev)
810 type="Development" 919 type="Development"
811 ;; 920 ;;
812 921
813 games) 922 games)
814 case ${catmin} in 923 case ${catmin} in
815 action) type=ActionGame;; 924 action|fps) type=ActionGame;;
816 arcade) type=ArcadeGame;; 925 arcade) type=ArcadeGame;;
817 board) type=BoardGame;; 926 board) type=BoardGame;;
818 kid) type=KidsGame;;
819 emulation) type=Emulator;; 927 emulation) type=Emulator;;
928 kids) type=KidsGame;;
820 puzzle) type=LogicGame;; 929 puzzle) type=LogicGame;;
930 roguelike) type=RolePlaying;;
821 rpg) type=RolePlaying;; 931 rpg) type=RolePlaying;;
822 roguelike) type=RolePlaying;;
823 simulation) type=Simulation;; 932 simulation) type=Simulation;;
824 sports) type=SportsGame;; 933 sports) type=SportsGame;;
825 strategy) type=StrategyGame;; 934 strategy) type=StrategyGame;;
826 *) type=;;
827 esac 935 esac
828 type="Game;${type}" 936 type="Game;${type}"
829 ;; 937 ;;
830 938
939 gnome)
940 type="Gnome;GTK"
941 ;;
942
943 kde)
944 type="KDE;Qt"
945 ;;
946
831 mail) 947 mail)
832 type="Network;Email" 948 type="Network;Email"
833 ;; 949 ;;
834 950
835 media) 951 media)
836 case ${catmin} in 952 case ${catmin} in
953 gfx)
837 gfx) type=Graphics;; 954 type=Graphics
955 ;;
956 *)
957 case ${catmin} in
838 radio) type=Tuner;; 958 radio) type=Tuner;;
839 sound) type=Audio;; 959 sound) type=Audio;;
840 tv) type=TV;; 960 tv) type=TV;;
841 video) type=Video;; 961 video) type=Video;;
842 *) type=;; 962 esac
963 type="AudioVideo;${type}"
964 ;;
843 esac 965 esac
844 type="AudioVideo;${type}"
845 ;; 966 ;;
846 967
847 net) 968 net)
848 case ${catmin} in 969 case ${catmin} in
849 dialup) type=Dialup;; 970 dialup) type=Dialup;;
852 irc) type=IRCClient;; 973 irc) type=IRCClient;;
853 mail) type=Email;; 974 mail) type=Email;;
854 news) type=News;; 975 news) type=News;;
855 nntp) type=News;; 976 nntp) type=News;;
856 p2p) type=FileTransfer;; 977 p2p) type=FileTransfer;;
857 *) type=;; 978 voip) type=Telephony;;
858 esac 979 esac
859 type="Network;${type}" 980 type="Network;${type}"
860 ;; 981 ;;
861 982
862 sci) 983 sci)
863 case ${catmin} in 984 case ${catmin} in
864 astro*) type=Astronomy;; 985 astro*) type=Astronomy;;
865 bio*) type=Biology;; 986 bio*) type=Biology;;
866 calc*) type=Calculator;; 987 calc*) type=Calculator;;
867 chem*) type=Chemistry;; 988 chem*) type=Chemistry;;
989 elec*) type=Electronics;;
868 geo*) type=Geology;; 990 geo*) type=Geology;;
869 math*) type=Math;; 991 math*) type=Math;;
870 *) type=;; 992 physics) type=Physics;;
993 visual*) type=DataVisualization;;
871 esac 994 esac
872 type="Science;${type}" 995 type="Education;Science;${type}"
996 ;;
997
998 sys)
999 type="System"
873 ;; 1000 ;;
874 1001
875 www) 1002 www)
876 case ${catmin} in 1003 case ${catmin} in
877 client) type=WebBrowser;; 1004 client) type=WebBrowser;;
878 *) type=;;
879 esac 1005 esac
880 type="Network" 1006 type="Network;${type}"
881 ;; 1007 ;;
882 1008
883 *) 1009 *)
884 type= 1010 type=
885 ;; 1011 ;;
888 if [ "${SLOT}" == "0" ] ; then 1014 if [ "${SLOT}" == "0" ] ; then
889 local desktop_name="${PN}" 1015 local desktop_name="${PN}"
890 else 1016 else
891 local desktop_name="${PN}-${SLOT}" 1017 local desktop_name="${PN}-${SLOT}"
892 fi 1018 fi
893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 1019 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1020 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 1021
1022 # Don't append another ";" when a valid category value is provided.
1023 type=${type%;}${type:+;}
1024
1025 eshopts_push -s extglob
1026 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1027 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1028 ewarn "allowed in .desktop files if the value is not an absolute path."
1029 icon=${icon%.@(xpm|png|svg)}
1030 fi
1031 eshopts_pop
1032
1033 cat <<-EOF > "${desktop}"
896echo "[Desktop Entry] 1034 [Desktop Entry]
897Encoding=UTF-8
898Version=0.9.2
899Name=${name} 1035 Name=${name}
900Type=Application 1036 Type=Application
901Comment=${DESCRIPTION} 1037 Comment=${DESCRIPTION}
902Exec=${exec} 1038 Exec=${exec}
903TryExec=${exec} 1039 TryExec=${exec%% *}
904Path=${path}
905Icon=${icon} 1040 Icon=${icon}
906Categories=Application;${type};" > "${desktop}" 1041 Categories=${type}
1042 EOF
1043
1044 if [[ ${fields:-=} != *=* ]] ; then
1045 # 5th arg used to be value to Path=
1046 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1047 fields="Path=${fields}"
1048 fi
1049 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
907 1050
908 ( 1051 (
909 # wrap the env here so that the 'insinto' call 1052 # wrap the env here so that the 'insinto' call
910 # doesn't corrupt the env of the caller 1053 # doesn't corrupt the env of the caller
911 insinto /usr/share/applications 1054 insinto /usr/share/applications
912 doins "${desktop}" 1055 doins "${desktop}"
913 ) 1056 ) || die "installing desktop file failed"
914} 1057}
915 1058
916# Make a GDM/KDM Session file 1059# @FUNCTION: validate_desktop_entries
917# 1060# @USAGE: [directories]
918# make_desktop_entry(<title>, <command>) 1061# @MAINTAINER:
919# title: File to execute to start the Window Manager 1062# Carsten Lohrke <carlo@gentoo.org>
920# command: Name of the Window Manager 1063# @DESCRIPTION:
1064# Validate desktop entries using desktop-file-utils
1065validate_desktop_entries() {
1066 if [[ -x /usr/bin/desktop-file-validate ]] ; then
1067 einfo "Checking desktop entry validity"
1068 local directories=""
1069 for d in /usr/share/applications $@ ; do
1070 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
1071 done
1072 if [[ -n ${directories} ]] ; then
1073 for FILE in $(find ${directories} -name "*\.desktop" \
1074 -not -path '*.hidden*' | sort -u 2>/dev/null)
1075 do
1076 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1077 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1078 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
1079 done
1080 fi
1081 echo ""
1082 else
1083 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1084 fi
1085}
921 1086
1087# @FUNCTION: make_session_desktop
1088# @USAGE: <title> <command> [command args...]
1089# @DESCRIPTION:
1090# Make a GDM/KDM Session file. The title is the file to execute to start the
1091# Window Manager. The command is the name of the Window Manager.
1092#
1093# You can set the name of the file via the ${wm} variable.
922make_session_desktop() { 1094make_session_desktop() {
923 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1095 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
924 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1096 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
925 1097
926 local title=$1 1098 local title=$1
927 local command=$2 1099 local command=$2
928 local desktop=${T}/${wm}.desktop 1100 local desktop=${T}/${wm:-${PN}}.desktop
1101 shift 2
929 1102
1103 cat <<-EOF > "${desktop}"
930echo "[Desktop Entry] 1104 [Desktop Entry]
931Encoding=UTF-8
932Name=${title} 1105 Name=${title}
933Comment=This session logs you into ${title} 1106 Comment=This session logs you into ${title}
934Exec=${command} 1107 Exec=${command} $*
935TryExec=${command} 1108 TryExec=${command}
936Type=Application" > "${desktop}" 1109 Type=XSession
1110 EOF
937 1111
1112 (
1113 # wrap the env here so that the 'insinto' call
1114 # doesn't corrupt the env of the caller
938 insinto /usr/share/xsessions 1115 insinto /usr/share/xsessions
939 doins "${desktop}" 1116 doins "${desktop}"
1117 )
940} 1118}
941 1119
1120# @FUNCTION: domenu
1121# @USAGE: <menus>
1122# @DESCRIPTION:
1123# Install the list of .desktop menu files into the appropriate directory
1124# (/usr/share/applications).
942domenu() { 1125domenu() {
1126 (
1127 # wrap the env here so that the 'insinto' call
1128 # doesn't corrupt the env of the caller
943 local i j 1129 local i j ret=0
944 insinto /usr/share/applications 1130 insinto /usr/share/applications
945 for i in "$@" ; do 1131 for i in "$@" ; do
946 if [[ -f ${i} ]] ; then 1132 if [[ -f ${i} ]] ; then
947 doins "${i}" 1133 doins "${i}"
1134 ((ret+=$?))
948 elif [[ -d ${i} ]] ; then 1135 elif [[ -d ${i} ]] ; then
949 for j in "${i}"/*.desktop ; do 1136 for j in "${i}"/*.desktop ; do
950 doins "${j}" 1137 doins "${j}"
1138 ((ret+=$?))
951 done 1139 done
1140 else
1141 ((++ret))
952 fi 1142 fi
953 done 1143 done
1144 exit ${ret}
1145 )
954} 1146}
1147
1148# @FUNCTION: newmenu
1149# @USAGE: <menu> <newname>
1150# @DESCRIPTION:
1151# Like all other new* functions, install the specified menu as newname.
955newmenu() { 1152newmenu() {
1153 (
1154 # wrap the env here so that the 'insinto' call
1155 # doesn't corrupt the env of the caller
956 insinto /usr/share/applications 1156 insinto /usr/share/applications
957 newins "$1" "$2" 1157 newins "$@"
1158 )
958} 1159}
959 1160
1161# @FUNCTION: doicon
1162# @USAGE: <list of icons>
1163# @DESCRIPTION:
1164# Install the list of icons into the icon directory (/usr/share/pixmaps).
1165# This is useful in conjunction with creating desktop/menu files.
960doicon() { 1166doicon() {
1167 (
1168 # wrap the env here so that the 'insinto' call
1169 # doesn't corrupt the env of the caller
961 local i j 1170 local i j ret
962 insinto /usr/share/pixmaps 1171 insinto /usr/share/pixmaps
963 for i in "$@" ; do 1172 for i in "$@" ; do
964 if [[ -f ${i} ]] ; then 1173 if [[ -f ${i} ]] ; then
965 doins "${i}" 1174 doins "${i}"
1175 ((ret+=$?))
966 elif [[ -d ${i} ]] ; then 1176 elif [[ -d ${i} ]] ; then
967 for j in "${i}"/*.png ; do 1177 for j in "${i}"/*.png ; do
968 doins "${j}" 1178 doins "${j}"
1179 ((ret+=$?))
969 done 1180 done
1181 else
1182 ((++ret))
970 fi 1183 fi
971 done 1184 done
1185 exit ${ret}
1186 )
972} 1187}
1188
1189# @FUNCTION: newicon
1190# @USAGE: <icon> <newname>
1191# @DESCRIPTION:
1192# Like all other new* functions, install the specified icon as newname.
973newicon() { 1193newicon() {
1194 (
1195 # wrap the env here so that the 'insinto' call
1196 # doesn't corrupt the env of the caller
974 insinto /usr/share/pixmaps 1197 insinto /usr/share/pixmaps
975 newins "$1" "$2" 1198 newins "$@"
1199 )
976} 1200}
977
978##############################################################
979# END: Handle .desktop files and menu entries #
980##############################################################
981
982 1201
983# for internal use only (unpack_pdv and unpack_makeself) 1202# for internal use only (unpack_pdv and unpack_makeself)
984find_unpackable_file() { 1203find_unpackable_file() {
985 local src=$1 1204 local src=$1
986 if [[ -z ${src} ]] ; then 1205 if [[ -z ${src} ]] ; then
996 fi 1215 fi
997 [[ ! -e ${src} ]] && return 1 1216 [[ ! -e ${src} ]] && return 1
998 echo "${src}" 1217 echo "${src}"
999} 1218}
1000 1219
1220# @FUNCTION: unpack_pdv
1221# @USAGE: <file to unpack> <size of off_t>
1222# @DESCRIPTION:
1001# Unpack those pesky pdv generated files ... 1223# Unpack those pesky pdv generated files ...
1002# They're self-unpacking programs with the binary package stuffed in 1224# They're self-unpacking programs with the binary package stuffed in
1003# the middle of the archive. Valve seems to use it a lot ... too bad 1225# the middle of the archive. Valve seems to use it a lot ... too bad
1004# it seems to like to segfault a lot :(. So lets take it apart ourselves. 1226# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1005# 1227#
1006# Usage: unpack_pdv [file to unpack] [size of off_t]
1007# - you have to specify the off_t size ... i have no idea how to extract that 1228# You have to specify the off_t size ... I have no idea how to extract that
1008# information out of the binary executable myself. basically you pass in 1229# information out of the binary executable myself. Basically you pass in
1009# the size of the off_t type (in bytes) on the machine that built the pdv 1230# the size of the off_t type (in bytes) on the machine that built the pdv
1231# archive.
1232#
1010# archive. one way to determine this is by running the following commands: 1233# One way to determine this is by running the following commands:
1234#
1235# @CODE
1011# strings <pdv archive> | grep lseek 1236# strings <pdv archive> | grep lseek
1012# strace -elseek <pdv archive> 1237# strace -elseek <pdv archive>
1238# @CODE
1239#
1013# basically look for the first lseek command (we do the strings/grep because 1240# Basically look for the first lseek command (we do the strings/grep because
1014# sometimes the function call is _llseek or something) and steal the 2nd 1241# sometimes the function call is _llseek or something) and steal the 2nd
1015# parameter. here is an example: 1242# parameter. Here is an example:
1243#
1244# @CODE
1016# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 1245# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1017# lseek 1246# lseek
1018# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1247# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1019# lseek(3, -4, SEEK_END) = 2981250 1248# lseek(3, -4, SEEK_END) = 2981250
1249# @CODE
1250#
1020# thus we would pass in the value of '4' as the second parameter. 1251# Thus we would pass in the value of '4' as the second parameter.
1021unpack_pdv() { 1252unpack_pdv() {
1022 local src=$(find_unpackable_file $1) 1253 local src=$(find_unpackable_file "$1")
1023 local sizeoff_t=$2 1254 local sizeoff_t=$2
1024 1255
1025 [[ -z ${src} ]] && die "Could not locate source for '$1'" 1256 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1026 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 1257 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1027 1258
1028 local shrtsrc=$(basename "${src}") 1259 local shrtsrc=$(basename "${src}")
1029 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1260 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1030 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1261 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1031 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1262 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1032 1263
1033 # grab metadata for debug reasons 1264 # grab metadata for debug reasons
1034 local metafile="$(emktemp)" 1265 local metafile=$(emktemp)
1035 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 1266 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1036 1267
1037 # rip out the final file name from the metadata 1268 # rip out the final file name from the metadata
1038 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 1269 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1039 datafile="`basename ${datafile}`" 1270 datafile=$(basename "${datafile}")
1040 1271
1041 # now lets uncompress/untar the file if need be 1272 # now lets uncompress/untar the file if need be
1042 local tmpfile="$(emktemp)" 1273 local tmpfile=$(emktemp)
1043 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 1274 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1044 1275
1045 local iscompressed="`file -b ${tmpfile}`" 1276 local iscompressed=$(file -b "${tmpfile}")
1046 if [ "${iscompressed:0:8}" == "compress" ] ; then 1277 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1047 iscompressed=1 1278 iscompressed=1
1048 mv ${tmpfile}{,.Z} 1279 mv ${tmpfile}{,.Z}
1049 gunzip ${tmpfile} 1280 gunzip ${tmpfile}
1050 else 1281 else
1051 iscompressed=0 1282 iscompressed=0
1052 fi 1283 fi
1053 local istar="`file -b ${tmpfile}`" 1284 local istar=$(file -b "${tmpfile}")
1054 if [ "${istar:0:9}" == "POSIX tar" ] ; then 1285 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1055 istar=1 1286 istar=1
1056 else 1287 else
1057 istar=0 1288 istar=0
1058 fi 1289 fi
1059 1290
1087 true 1318 true
1088 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1319 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1089 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 1320 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1090} 1321}
1091 1322
1323# @FUNCTION: unpack_makeself
1324# @USAGE: [file to unpack] [offset] [tail|dd]
1325# @DESCRIPTION:
1092# Unpack those pesky makeself generated files ... 1326# Unpack those pesky makeself generated files ...
1093# They're shell scripts with the binary package tagged onto 1327# They're shell scripts with the binary package tagged onto
1094# the end of the archive. Loki utilized the format as does 1328# the end of the archive. Loki utilized the format as does
1095# many other game companies. 1329# many other game companies.
1096# 1330#
1097# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1331# If the file is not specified, then ${A} is used. If the
1098# - If the file is not specified then unpack will utilize ${A}.
1099# - If the offset is not specified then we will attempt to extract 1332# offset is not specified then we will attempt to extract
1100# the proper offset from the script itself. 1333# the proper offset from the script itself.
1101unpack_makeself() { 1334unpack_makeself() {
1102 local src_input=${1:-${A}} 1335 local src_input=${1:-${A}}
1103 local src=$(find_unpackable_file "${src_input}") 1336 local src=$(find_unpackable_file "${src_input}")
1104 local skip=$2 1337 local skip=$2
1105 local exe=$3 1338 local exe=$3
1107 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1340 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1108 1341
1109 local shrtsrc=$(basename "${src}") 1342 local shrtsrc=$(basename "${src}")
1110 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1343 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1111 if [[ -z ${skip} ]] ; then 1344 if [[ -z ${skip} ]] ; then
1112 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1345 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1113 local skip=0 1346 local skip=0
1114 exe=tail 1347 exe=tail
1115 case ${ver} in 1348 case ${ver} in
1116 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1349 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1117 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1350 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1118 ;; 1351 ;;
1119 2.0|2.0.1) 1352 2.0|2.0.1)
1120 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1353 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1121 ;; 1354 ;;
1122 2.1.1) 1355 2.1.1)
1123 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1356 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1124 let skip="skip + 1" 1357 (( skip++ ))
1125 ;; 1358 ;;
1126 2.1.2) 1359 2.1.2)
1127 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1360 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1128 let skip="skip + 1" 1361 (( skip++ ))
1129 ;; 1362 ;;
1130 2.1.3) 1363 2.1.3)
1131 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1364 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1132 let skip="skip + 1" 1365 (( skip++ ))
1133 ;; 1366 ;;
1134 2.1.4|2.1.5) 1367 2.1.4|2.1.5)
1135 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1368 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1136 skip=$(head -n ${skip} "${src}" | wc -c) 1369 skip=$(head -n ${skip} "${src}" | wc -c)
1137 exe="dd" 1370 exe="dd"
1146 esac 1379 esac
1147 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1380 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1148 fi 1381 fi
1149 case ${exe} in 1382 case ${exe} in
1150 tail) exe="tail -n +${skip} '${src}'";; 1383 tail) exe="tail -n +${skip} '${src}'";;
1151 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1384 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1152 *) die "makeself cant handle exe '${exe}'" 1385 *) die "makeself cant handle exe '${exe}'"
1153 esac 1386 esac
1154 1387
1155 # lets grab the first few bytes of the file to figure out what kind of archive it is 1388 # lets grab the first few bytes of the file to figure out what kind of archive it is
1156 local tmpfile="$(emktemp)" 1389 local tmpfile=$(emktemp)
1157 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1390 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1158 local filetype="$(file -b "${tmpfile}")" 1391 local filetype=$(file -b "${tmpfile}")
1159 case ${filetype} in 1392 case ${filetype} in
1160 *tar\ archive) 1393 *tar\ archive*)
1161 eval ${exe} | tar --no-same-owner -xf - 1394 eval ${exe} | tar --no-same-owner -xf -
1162 ;; 1395 ;;
1163 bzip2*) 1396 bzip2*)
1164 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1397 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1165 ;; 1398 ;;
1175 ;; 1408 ;;
1176 esac 1409 esac
1177 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1410 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1178} 1411}
1179 1412
1413# @FUNCTION: check_license
1414# @USAGE: [license]
1415# @DESCRIPTION:
1180# Display a license for user to accept. 1416# Display a license for user to accept. If no license is
1181#
1182# Usage: check_license [license]
1183# - If the file is not specified then ${LICENSE} is used. 1417# specified, then ${LICENSE} is used.
1184check_license() { 1418check_license() {
1185 local lic=$1 1419 local lic=$1
1186 if [ -z "${lic}" ] ; then 1420 if [ -z "${lic}" ] ; then
1187 lic="${PORTDIR}/licenses/${LICENSE}" 1421 lic="${PORTDIR}/licenses/${LICENSE}"
1188 else 1422 else
1192 lic="${PWD}/${lic}" 1426 lic="${PWD}/${lic}"
1193 elif [ -e "${lic}" ] ; then 1427 elif [ -e "${lic}" ] ; then
1194 lic="${lic}" 1428 lic="${lic}"
1195 fi 1429 fi
1196 fi 1430 fi
1197 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1198 local l="`basename ${lic}`" 1431 local l="`basename ${lic}`"
1199 1432
1200 # here is where we check for the licenses the user already 1433 # here is where we check for the licenses the user already
1201 # accepted ... if we don't find a match, we make the user accept 1434 # accepted ... if we don't find a match, we make the user accept
1202 local shopts=$-
1203 local alic 1435 local alic
1204 set -o noglob #so that bash doesn't expand "*" 1436 eshopts_push -o noglob # so that bash doesn't expand "*"
1205 for alic in ${ACCEPT_LICENSE} ; do 1437 for alic in ${ACCEPT_LICENSE} ; do
1206 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1438 if [[ ${alic} == ${l} ]]; then
1207 set +o noglob; set -${shopts} #reset old shell opts 1439 eshopts_pop
1208 return 0 1440 return 0
1209 fi 1441 fi
1210 done 1442 done
1211 set +o noglob; set -$shopts #reset old shell opts 1443 eshopts_pop
1444 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1212 1445
1213 local licmsg="$(emktemp)" 1446 local licmsg=$(emktemp)
1214 cat << EOF > ${licmsg} 1447 cat <<-EOF > ${licmsg}
1215********************************************************** 1448 **********************************************************
1216The following license outlines the terms of use of this 1449 The following license outlines the terms of use of this
1217package. You MUST accept this license for installation to 1450 package. You MUST accept this license for installation to
1218continue. When you are done viewing, hit 'q'. If you 1451 continue. When you are done viewing, hit 'q'. If you
1219CTRL+C out of this, the install will not run! 1452 CTRL+C out of this, the install will not run!
1220********************************************************** 1453 **********************************************************
1221 1454
1222EOF 1455 EOF
1223 cat ${lic} >> ${licmsg} 1456 cat ${lic} >> ${licmsg}
1224 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1457 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1225 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1458 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1226 read alic 1459 read alic
1227 case ${alic} in 1460 case ${alic} in
1234 die "Failed to accept license" 1467 die "Failed to accept license"
1235 ;; 1468 ;;
1236 esac 1469 esac
1237} 1470}
1238 1471
1472# @FUNCTION: cdrom_get_cds
1473# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1474# @DESCRIPTION:
1239# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1475# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1240# the whole 'non-interactive' policy, but damnit I want CD support ! 1476# the whole 'non-interactive' policy, but damnit I want CD support !
1241# 1477#
1242# with these cdrom functions we handle all the user interaction and 1478# With these cdrom functions we handle all the user interaction and
1243# standardize everything. all you have to do is call cdrom_get_cds() 1479# standardize everything. All you have to do is call cdrom_get_cds()
1244# and when the function returns, you can assume that the cd has been 1480# and when the function returns, you can assume that the cd has been
1245# found at CDROM_ROOT. 1481# found at CDROM_ROOT.
1246# 1482#
1483# The function will attempt to locate a cd based upon a file that is on
1484# the cd. The more files you give this function, the more cds
1485# the cdrom functions will handle.
1486#
1247# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1487# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1248# etc... if you want to give the cds better names, then just export 1488# etc... If you want to give the cds better names, then just export
1249# the CDROM_NAME_X variables before calling cdrom_get_cds(). 1489# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1490# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1491# also use the CDROM_NAME_SET bash array.
1250# 1492#
1251# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1493# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1252#
1253# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1254# - this will attempt to locate a cd based upon a file that is on
1255# the cd ... the more files you give this function, the more cds
1256# the cdrom functions will handle
1257cdrom_get_cds() { 1494cdrom_get_cds() {
1258 # first we figure out how many cds we're dealing with by 1495 # first we figure out how many cds we're dealing with by
1259 # the # of files they gave us 1496 # the # of files they gave us
1260 local cdcnt=0 1497 local cdcnt=0
1261 local f= 1498 local f=
1285 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1522 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1286 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1523 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1287 export CDROM_SET=-1 1524 export CDROM_SET=-1
1288 for f in ${CDROM_CHECK_1//:/ } ; do 1525 for f in ${CDROM_CHECK_1//:/ } ; do
1289 ((++CDROM_SET)) 1526 ((++CDROM_SET))
1290 [[ -e ${CD_ROOT}/${f} ]] && break 1527 [[ -e ${CDROM_ROOT}/${f} ]] && break
1291 done 1528 done
1292 export CDROM_MATCH=${f} 1529 export CDROM_MATCH=${f}
1293 return 1530 return
1294 fi 1531 fi
1295 1532
1305 echo 1542 echo
1306 einfo "For example:" 1543 einfo "For example:"
1307 einfo "export CD_ROOT=/mnt/cdrom" 1544 einfo "export CD_ROOT=/mnt/cdrom"
1308 echo 1545 echo
1309 else 1546 else
1547 if [[ -n ${CDROM_NAME_SET} ]] ; then
1548 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1549 cdcnt=0
1550 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1551 ((++cdcnt))
1552 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1553 done
1554 fi
1555
1310 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1556 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1311 cdcnt=0 1557 cdcnt=0
1312 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1558 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1313 ((++cdcnt)) 1559 ((++cdcnt))
1314 var="CDROM_NAME_${cdcnt}" 1560 var="CDROM_NAME_${cdcnt}"
1338 export CDROM_SET="" 1584 export CDROM_SET=""
1339 export CDROM_CURRENT_CD=0 1585 export CDROM_CURRENT_CD=0
1340 cdrom_load_next_cd 1586 cdrom_load_next_cd
1341} 1587}
1342 1588
1343# this is only used when you need access to more than one cd. 1589# @FUNCTION: cdrom_load_next_cd
1344# when you have finished using the first cd, just call this function. 1590# @DESCRIPTION:
1345# when it returns, CDROM_ROOT will be pointing to the second cd. 1591# Some packages are so big they come on multiple CDs. When you're done reading
1346# remember, you can only go forward in the cd chain, you can't go back. 1592# files off a CD and want access to the next one, just call this function.
1593# Again, all the messy details of user interaction are taken care of for you.
1594# Once this returns, just read the variable CDROM_ROOT for the location of the
1595# mounted CD. Note that you can only go forward in the CD list, so make sure
1596# you only call this function when you're done using the current CD.
1347cdrom_load_next_cd() { 1597cdrom_load_next_cd() {
1348 local var 1598 local var
1349 ((++CDROM_CURRENT_CD)) 1599 ((++CDROM_CURRENT_CD))
1350 1600
1351 unset CDROM_ROOT 1601 unset CDROM_ROOT
1368# displayed and we'll hang out here until: 1618# displayed and we'll hang out here until:
1369# (1) the file is found on a mounted cdrom 1619# (1) the file is found on a mounted cdrom
1370# (2) the user hits CTRL+C 1620# (2) the user hits CTRL+C
1371_cdrom_locate_file_on_cd() { 1621_cdrom_locate_file_on_cd() {
1372 local mline="" 1622 local mline=""
1373 local showedmsg=0 1623 local showedmsg=0 showjolietmsg=0
1374 1624
1375 while [[ -z ${CDROM_ROOT} ]] ; do 1625 while [[ -z ${CDROM_ROOT} ]] ; do
1376 local i=0 1626 local i=0
1377 local -a cdset=(${*//:/ }) 1627 local -a cdset=(${*//:/ })
1378 if [[ -n ${CDROM_SET} ]] ; then 1628 if [[ -n ${CDROM_SET} ]] ; then
1381 1631
1382 while [[ -n ${cdset[${i}]} ]] ; do 1632 while [[ -n ${cdset[${i}]} ]] ; do
1383 local dir=$(dirname ${cdset[${i}]}) 1633 local dir=$(dirname ${cdset[${i}]})
1384 local file=$(basename ${cdset[${i}]}) 1634 local file=$(basename ${cdset[${i}]})
1385 1635
1386 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1636 local point= node= fs= foo=
1637 while read point node fs foo ; do
1638 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1639 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1640 && continue
1641 point=${point//\040/ }
1387 [[ -d ${mline}/${dir} ]] || continue 1642 [[ ! -d ${point}/${dir} ]] && continue
1388 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1643 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1389 export CDROM_ROOT=${mline} 1644 export CDROM_ROOT=${point}
1390 export CDROM_SET=${i} 1645 export CDROM_SET=${i}
1391 export CDROM_MATCH=${cdset[${i}]} 1646 export CDROM_MATCH=${cdset[${i}]}
1392 return 1647 return
1393 fi 1648 done <<< "$(get_mounts)"
1394 done
1395 1649
1396 ((++i)) 1650 ((++i))
1397 done 1651 done
1398 1652
1399 echo 1653 echo
1415 showedmsg=1 1669 showedmsg=1
1416 fi 1670 fi
1417 einfo "Press return to scan for the cd again" 1671 einfo "Press return to scan for the cd again"
1418 einfo "or hit CTRL+C to abort the emerge." 1672 einfo "or hit CTRL+C to abort the emerge."
1419 echo 1673 echo
1674 if [[ ${showjolietmsg} -eq 0 ]] ; then
1675 showjolietmsg=1
1676 else
1420 einfo "If you are having trouble with the detection" 1677 ewarn "If you are having trouble with the detection"
1421 einfo "of your CD, it is possible that you do not have" 1678 ewarn "of your CD, it is possible that you do not have"
1422 einfo "Joliet support enabled in your kernel. Please" 1679 ewarn "Joliet support enabled in your kernel. Please"
1423 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1680 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1681 ebeep 5
1682 fi
1424 read || die "something is screwed with your system" 1683 read || die "something is screwed with your system"
1425 done 1684 done
1426} 1685}
1427 1686
1687# @FUNCTION: strip-linguas
1688# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1689# @DESCRIPTION:
1428# Make sure that LINGUAS only contains languages that 1690# Make sure that LINGUAS only contains languages that
1429# a package can support 1691# a package can support. The first form allows you to
1430# 1692# specify a list of LINGUAS. The -i builds a list of po
1431# usage: strip-linguas <allow LINGUAS> 1693# files found in all the directories and uses the
1432# strip-linguas -i <directories of .po files> 1694# intersection of the lists. The -u builds a list of po
1433# strip-linguas -u <directories of .po files> 1695# files found in all the directories and uses the union
1434# 1696# of the lists.
1435# The first form allows you to specify a list of LINGUAS.
1436# The -i builds a list of po files found in all the
1437# directories and uses the intersection of the lists.
1438# The -u builds a list of po files found in all the
1439# directories and uses the union of the lists.
1440strip-linguas() { 1697strip-linguas() {
1441 local ls newls 1698 local ls newls nols
1442 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1699 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1443 local op=$1; shift 1700 local op=$1; shift
1444 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1701 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1445 local d f 1702 local d f
1446 for d in "$@" ; do 1703 for d in "$@" ; do
1447 if [[ ${op} == "-u" ]] ; then 1704 if [[ ${op} == "-u" ]] ; then
1448 newls=${ls} 1705 newls=${ls}
1449 else 1706 else
1450 newls="" 1707 newls=""
1451 fi 1708 fi
1452 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1709 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1453 if [[ ${op} == "-i" ]] ; then 1710 if [[ ${op} == "-i" ]] ; then
1454 hasq ${f} ${ls} && newls="${newls} ${f}" 1711 hasq ${f} ${ls} && newls="${newls} ${f}"
1455 else 1712 else
1456 hasq ${f} ${ls} || newls="${newls} ${f}" 1713 hasq ${f} ${ls} || newls="${newls} ${f}"
1457 fi 1714 fi
1460 done 1717 done
1461 else 1718 else
1462 ls="$@" 1719 ls="$@"
1463 fi 1720 fi
1464 1721
1722 nols=""
1465 newls="" 1723 newls=""
1466 for f in ${LINGUAS} ; do 1724 for f in ${LINGUAS} ; do
1467 if hasq ${f} ${ls} ; then 1725 if hasq ${f} ${ls} ; then
1468 newls="${newls} ${f}" 1726 newls="${newls} ${f}"
1469 else 1727 else
1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1728 nols="${nols} ${f}"
1471 fi 1729 fi
1472 done 1730 done
1473 if [[ -z ${newls} ]] ; then 1731 [[ -n ${nols} ]] \
1474 export LINGUAS="" 1732 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1475 else
1476 export LINGUAS=${newls:1} 1733 export LINGUAS=${newls:1}
1477 fi
1478} 1734}
1479 1735
1480# moved from kernel.eclass since they are generally useful outside of 1736# @FUNCTION: preserve_old_lib
1481# kernel.eclass -iggy (20041002) 1737# @USAGE: <libs to preserve> [more libs]
1482 1738# @DESCRIPTION:
1483# the following functions are useful in kernel module ebuilds, etc.
1484# for an example see ivtv or drbd ebuilds
1485
1486# set's ARCH to match what the kernel expects
1487set_arch_to_kernel() {
1488 i=10
1489 while ((i--)) ; do
1490 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1491 done
1492 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1493 case ${ARCH} in
1494 x86) export ARCH="i386";;
1495 amd64) export ARCH="x86_64";;
1496 hppa) export ARCH="parisc";;
1497 mips) export ARCH="mips";;
1498 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1499 *) export ARCH="${ARCH}";;
1500 esac
1501}
1502
1503# set's ARCH back to what portage expects
1504set_arch_to_portage() {
1505 i=10
1506 while ((i--)) ; do
1507 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1508 done
1509 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1510}
1511
1512# Jeremy Huddleston <eradicator@gentoo.org>:
1513# preserve_old_lib /path/to/libblah.so.0
1514# preserve_old_lib_notify /path/to/libblah.so.0
1515#
1516# These functions are useful when a lib in your package changes --library. Such 1739# These functions are useful when a lib in your package changes ABI SONAME.
1517# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1740# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1518# would break packages that link against it. Most people get around this 1741# would break packages that link against it. Most people get around this
1519# by using the portage SLOT mechanism, but that is not always a relevant 1742# by using the portage SLOT mechanism, but that is not always a relevant
1520# solution, so instead you can add the following to your ebuilds: 1743# solution, so instead you can call this from pkg_preinst. See also the
1521# 1744# preserve_old_lib_notify function.
1522# src_install() {
1523# ...
1524# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1525# ...
1526# }
1527#
1528# pkg_postinst() {
1529# ...
1530# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1531# ...
1532# }
1533
1534preserve_old_lib() { 1745preserve_old_lib() {
1535 LIB=$1 1746 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1747 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1748 die "Invalid preserve_old_lib() usage"
1749 fi
1750 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1536 1751
1537 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1752 # let portage worry about it
1538 SONAME=`basename ${LIB}` 1753 has preserve-libs ${FEATURES} && return 0
1539 DIRNAME=`dirname ${LIB}`
1540 1754
1541 dodir ${DIRNAME} 1755 local lib dir
1542 cp ${ROOT}${LIB} ${D}${DIRNAME} 1756 for lib in "$@" ; do
1757 [[ -e ${ROOT}/${lib} ]] || continue
1758 dir=${lib%/*}
1759 dodir ${dir} || die "dodir ${dir} failed"
1760 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1543 touch ${D}${LIB} 1761 touch "${D}"/${lib}
1544 fi 1762 done
1545} 1763}
1546 1764
1765# @FUNCTION: preserve_old_lib_notify
1766# @USAGE: <libs to notify> [more libs]
1767# @DESCRIPTION:
1768# Spit helpful messages about the libraries preserved by preserve_old_lib.
1547preserve_old_lib_notify() { 1769preserve_old_lib_notify() {
1548 LIB=$1 1770 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1771 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1772 die "Invalid preserve_old_lib_notify() usage"
1773 fi
1549 1774
1550 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1775 # let portage worry about it
1551 SONAME=`basename ${LIB}` 1776 has preserve-libs ${FEATURES} && return 0
1552 1777
1778 local lib notice=0
1779 for lib in "$@" ; do
1780 [[ -e ${ROOT}/${lib} ]] || continue
1781 if [[ ${notice} -eq 0 ]] ; then
1782 notice=1
1553 ewarn "An old version of an installed library was detected on your system." 1783 ewarn "Old versions of installed libraries were detected on your system."
1554 ewarn "In order to avoid breaking packages that link against it, this older version" 1784 ewarn "In order to avoid breaking packages that depend on these old libs,"
1555 ewarn "is not being removed. In order to make full use of this newer version," 1785 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1556 ewarn "you will need to execute the following command:" 1786 ewarn "in order to remove these old dependencies. If you do not have this"
1787 ewarn "helper program, simply emerge the 'gentoolkit' package."
1788 ewarn
1789 fi
1557 ewarn " revdep-rebuild --library ${SONAME}" 1790 ewarn " # revdep-rebuild --library ${lib##*/}"
1791 done
1792 if [[ ${notice} -eq 1 ]] ; then
1558 ewarn 1793 ewarn
1559 ewarn "After doing that, you can safely remove ${LIB}" 1794 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1560 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1795 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1796 for lib in "$@" ; do
1797 ewarn " # rm '${lib}'"
1798 done
1561 fi 1799 fi
1562} 1800}
1563 1801
1564# Hack for people to figure out if a package was built with 1802# @FUNCTION: built_with_use
1565# certain USE flags 1803# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1804# @DESCRIPTION:
1566# 1805#
1567# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1806# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1568# ex: built_with_use xchat gtk2
1569# 1807#
1570# Flags: -a all USE flags should be utilized 1808# A temporary hack until portage properly supports DEPENDing on USE
1571# -o at least one USE flag should be utilized 1809# flags being enabled in packages. This will check to see if the specified
1572# Note: the default flag is '-a' 1810# DEPEND atom was built with the specified list of USE flags. The
1811# --missing option controls the behavior if called on a package that does
1812# not actually support the defined USE flags (aka listed in IUSE).
1813# The default is to abort (call die). The -a and -o flags control
1814# the requirements of the USE flags. They correspond to "and" and "or"
1815# logic. So the -a flag means all listed USE flags must be enabled
1816# while the -o flag means at least one of the listed IUSE flags must be
1817# enabled. The --hidden option is really for internal use only as it
1818# means the USE flag we're checking is hidden expanded, so it won't be found
1819# in IUSE like normal USE flags.
1820#
1821# Remember that this function isn't terribly intelligent so order of optional
1822# flags matter.
1573built_with_use() { 1823built_with_use() {
1824 local hidden="no"
1825 if [[ $1 == "--hidden" ]] ; then
1826 hidden="yes"
1827 shift
1828 fi
1829
1830 local missing_action="die"
1831 if [[ $1 == "--missing" ]] ; then
1832 missing_action=$2
1833 shift ; shift
1834 case ${missing_action} in
1835 true|false|die) ;;
1836 *) die "unknown action '${missing_action}'";;
1837 esac
1838 fi
1839
1574 local opt=$1 1840 local opt=$1
1575 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1841 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1576 1842
1577 local PKG=$(best_version $1) 1843 local PKG=$(best_version $1)
1844 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1578 shift 1845 shift
1579 1846
1580 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1847 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1848 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1581 1849
1582 # if the USE file doesnt exist, assume the $PKG is either 1850 # if the IUSE file doesn't exist, the read will error out, we need to handle
1583 # injected or package.provided 1851 # this gracefully
1584 [[ ! -e ${USEFILE} ]] && return 0 1852 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1853 case ${missing_action} in
1854 true) return 0;;
1855 false) return 1;;
1856 die) die "Unable to determine what USE flags $PKG was built with";;
1857 esac
1858 fi
1859
1860 if [[ ${hidden} == "no" ]] ; then
1861 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1862 # Don't check USE_EXPAND #147237
1863 local expand
1864 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1865 if [[ $1 == ${expand}_* ]] ; then
1866 expand=""
1867 break
1868 fi
1869 done
1870 if [[ -n ${expand} ]] ; then
1871 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1872 case ${missing_action} in
1873 true) return 0;;
1874 false) return 1;;
1875 die) die "$PKG does not actually support the $1 USE flag!";;
1876 esac
1877 fi
1878 fi
1879 fi
1585 1880
1586 local USE_BUILT=$(<${USEFILE}) 1881 local USE_BUILT=$(<${USEFILE})
1587 while [[ $# -gt 0 ]] ; do 1882 while [[ $# -gt 0 ]] ; do
1588 if [[ ${opt} = "-o" ]] ; then 1883 if [[ ${opt} = "-o" ]] ; then
1589 has $1 ${USE_BUILT} && return 0 1884 has $1 ${USE_BUILT} && return 0
1593 shift 1888 shift
1594 done 1889 done
1595 [[ ${opt} = "-a" ]] 1890 [[ ${opt} = "-a" ]]
1596} 1891}
1597 1892
1893# @FUNCTION: epunt_cxx
1894# @USAGE: [dir to scan]
1895# @DESCRIPTION:
1598# Many configure scripts wrongly bail when a C++ compiler 1896# Many configure scripts wrongly bail when a C++ compiler could not be
1599# could not be detected. #73450 1897# detected. If dir is not specified, then it defaults to ${S}.
1898#
1899# http://bugs.gentoo.org/73450
1600epunt_cxx() { 1900epunt_cxx() {
1601 local dir=$1 1901 local dir=$1
1602 [[ -z ${dir} ]] && dir=${S} 1902 [[ -z ${dir} ]] && dir=${S}
1603 ebegin "Removing useless C++ checks" 1903 ebegin "Removing useless C++ checks"
1604 local f 1904 local f
1605 for f in $(find ${dir} -name configure) ; do 1905 find "${dir}" -name configure | while read f ; do
1606 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1906 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1607 done 1907 done
1608 eend 0 1908 eend 0
1609} 1909}
1610 1910
1611# dopamd <file> [more files] 1911# @FUNCTION: make_wrapper
1612# 1912# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1613# Install pam auth config file in /etc/pam.d 1913# @DESCRIPTION:
1614dopamd() { 1914# Create a shell wrapper script named wrapper in installpath
1615 [[ -z $1 ]] && die "dopamd requires at least one argument" 1915# (defaults to the bindir) to execute target (default of wrapper) by
1616 1916# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1617 use pam || return 0 1917# libpaths followed by optionally changing directory to chdir.
1618
1619 INSDESTTREE=/etc/pam.d \
1620 doins "$@" || die "failed to install $@"
1621}
1622# newpamd <old name> <new name>
1623#
1624# Install pam file <old name> as <new name> in /etc/pam.d
1625newpamd() {
1626 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1627
1628 use pam || return 0
1629
1630 INSDESTTREE=/etc/pam.d \
1631 newins "$1" "$2" || die "failed to install $1 as $2"
1632}
1633
1634# make a wrapper script ...
1635# NOTE: this was originally games_make_wrapper, but I noticed other places where
1636# this could be used, so I have moved it here and made it not games-specific
1637# -- wolf31o2
1638# $1 == wrapper name
1639# $2 == binary to run
1640# $3 == directory to chdir before running binary
1641# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1642# $5 == path for wrapper
1643make_wrapper() { 1918make_wrapper() {
1644 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1919 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1645 local tmpwrapper=$(emktemp) 1920 local tmpwrapper=$(emktemp)
1646 # We don't want to quote ${bin} so that people can pass complex 1921 # We don't want to quote ${bin} so that people can pass complex
1647 # things as $bin ... "./someprog --args" 1922 # things as $bin ... "./someprog --args"
1657fi 1932fi
1658exec ${bin} "\$@" 1933exec ${bin} "\$@"
1659EOF 1934EOF
1660 chmod go+rx "${tmpwrapper}" 1935 chmod go+rx "${tmpwrapper}"
1661 if [[ -n ${path} ]] ; then 1936 if [[ -n ${path} ]] ; then
1937 (
1662 exeinto "${path}" 1938 exeinto "${path}"
1663 newexe "${tmpwrapper}" "${wrapper}" 1939 newexe "${tmpwrapper}" "${wrapper}"
1940 ) || die
1664 else 1941 else
1665 newbin "${tmpwrapper}" "${wrapper}" 1942 newbin "${tmpwrapper}" "${wrapper}" || die
1943 fi
1944}
1945
1946# @FUNCTION: prepalldocs
1947# @USAGE:
1948# @DESCRIPTION:
1949# Compress files in /usr/share/doc which are not already
1950# compressed, excluding /usr/share/doc/${PF}/html.
1951# Uses the ecompressdir to do the compression.
1952# 2009-02-18 by betelgeuse:
1953# Commented because ecompressdir is even more internal to
1954# Portage than prepalldocs (it's not even mentioned in man 5
1955# ebuild). Please submit a better version for review to gentoo-dev
1956# if you want prepalldocs here.
1957#prepalldocs() {
1958# if [[ -n $1 ]] ; then
1959# ewarn "prepalldocs: invalid usage; takes no arguments"
1666 fi 1960# fi
1667} 1961
1962# cd "${D}"
1963# [[ -d usr/share/doc ]] || return 0
1964
1965# find usr/share/doc -exec gzip {} +
1966# ecompressdir --ignore /usr/share/doc/${PF}/html
1967# ecompressdir --queue /usr/share/doc
1968#}

Legend:
Removed from v.1.236  
changed lines
  Added in v.1.349

  ViewVC Help
Powered by ViewVC 1.1.20